##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##  Copyright (C) 2018 Altered Vision (Tw:@alteredvision) / David Torrijos / Emilio Serrano / Jose MAnuel Malagón 
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------

.area _DATA
.area _CODE

.include "entity.h.s"
.include "ball.h.s"
.include "global.h.s"
.include "palos.h.s"
.include "marcador.h.s"

.globl _bola_sp_0

;;.globl _fondo_sp

;;-----------------------------DATA-----------------------------------
DefineEntity ball_data, 0x25, 0x9A, 0x09, 0x12, #-8, #-1, _bola_sp_0 , entBallUpdate
         ;;              X,    Y,     W,    H,    vx, vy,  puntero a sprite, puntero a update    


parabola_y:
   .db #-1

vel_x:   .db #00 ;;Velocidad de la pelota en X
vel_y:   .db #-1 ;;Velocidad de la pleota en Y

;;-----------------------------------------------------------------------


;;---------------------FUNCIONES-----------------------------------------
;;=======================================================================

;; ==========================BALL=============================================
;;-------------------------BORRAR BALL----------------------------
;; (te borra las pelotas) :D
borraBall::


  ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                    ;;Y
   call cpct_getScreenPtr_asm

   ex de, hl                        ;;Puntero a memoria
   ;;ld l, e_sp_l(ix)                 ;;leo el bajo
   ;;ld h, e_sp_h(ix)                 ;;leo el alto
   ld hl, #_fondo_sp
   ld b, #0x12                    ;;Tamanyo
   ld c, #0x09                    ;;Tamanyo

   call cpct_drawSprite_asm

   ret

;;--------------------------------------------------------------


;;--------------------------------------------------------------

entBallUpdate::
   call mueve        ;;mueve la pelota o no :D
   call ball_checkCollission;;chequea las colisiones con la pelota
   ret


;;----------------CHECK COLISION----------------------------
;;Input
;; HL : Pointer al principio de la entidad con la que voy a comprar las colisiones
;; Return: xxxx
;;
ball_checkCollission:

   ld ix, #ball_data    ;; preparamos los datos del player
   ;;
   ;; if(ball_x + ball_w =< player_x) no_colisionan
   ;;
   ;; ball_x + ball_w - player_x <=0 , gracias ensamblador :D
   ld a, e_x(ix)
   ld c, a
   ld a, e_w(ix)

   add c                ;;Sumamos ball_x + ball_w
                     ;; HL tiene el player_x
   ld ix, #player_data     ;; cargamos en HL el player_X
   ld b, e_x(ix)

   sub b             ;;resta de lo que hay en el acumulador
                     ;; si la resta da 0 ----> flag 0 activado
                     ;; si la resta de negativo ---> flag s esta a 1
                     ;; si la resta da positivo ---> flag S esta a 0
   jr z, no_colisiona      ;; =           
   jp m, no_colisiona      ;; <

   ;;
   ;;if(player_x + player_w <= ball_x) no_colisionan
   ;; player_x + player_w - ball_x <=0
   ;;
   ld ix, #player_data
   ld a, e_x(ix)
   ld c, a
   ld a, e_w(ix)
   add c

   ld ix, #ball_data
   ld b, e_x(ix)

   sub b

   jr z, no_colisiona      ;; =           
   jp m, no_colisiona      ;; <

   ;;=========COLISIONA EN EJE Y CON PLAYER================================
   ;;
   ;;if(player_y + player_h <= ball_y)
   ;; player_y + player_h - ball_y <= 0
   ld ix, #player_data
   ld a, e_y(ix)
   ld c, a
   ld a, e_h(ix)
   add c

   ld ix, #ball_data
   ld b, e_y(ix)

   sub b

   jr z, no_colisiona      ;; =           
   jp m, no_colisiona      ;; <

   ;;if(ball_y + ball_h <= player_y)
   ;; ball_y + ball_h - player_y<= 0
   ld ix, #ball_data
   ld a, e_y(ix)
   ld c, a
   ld a, e_h(ix)
   add c

   ld ix, #player_data
   ld b, e_y(ix)

   sub b

   jr z, no_colisiona      ;; =           
   jp m, no_colisiona      ;; <

;;=========================================================
   ;;----------COLISION*--------------------

   ld a, (vel_x)        ;;cargamos en a la velocidad de la pelota
   ld a, #1        ;;la velocidad de la pelota pasa a ser 1
   ld (vel_x), a        ;; cargamos la velocidad

   ld a, (vel_y)
   cp #-1
   jr z, sube
   cp #1
   jr z, subes
   cp #00
   jr z, sube
   ret
   subes:
   ld a, #1
   ld (vel_y),a
   ret

   sube:
   ld a, #-1
   ld (vel_y),a
   ;;------------------------------------------
   ;;
   ret 
   
   ;;NO colisiona

   no_colisiona:
      ld a, #00
;;===================CON RIVAL========================================
   ld ix, #ball_data    ;; preparamos los datos del player

   ;;
   ;; if(ball_x + ball_w =< player_x) no_colisionan
   ;;
   ;; ball_x + ball_w - player_x <=0 , gracias ensamblador :D

   ld a, e_x(ix)
   ld c, a
   ld a, e_w(ix)
   add c                ;;Sumamos ball_x + ball_w
                     ;; HL tiene el player_x
   ld ix, #rival_data      ;; cargamos en HL el player_X
   ld b, e_x(ix)

   sub b             ;;resta de lo que hay en el acumulador
                     ;; si la resta da 0 ----> flag 0 activado
                     ;; si la resta de negativo ---> flag s esta a 1
                     ;; si la resta da positivo ---> flag S esta a 0
   jr z, no_colisionas     ;; =           
   jp m, no_colisionas     ;; <

   ;;
   ;;if(player_x + player_w <= ball_x) no_colisionan
   ;; player_x + player_w - ball_x <=0
   ;;
   ld ix, #rival_data
   ld a, e_x(ix)
   ld c, a
   ld a, e_w(ix)
   add c

   ld ix, #ball_data
   ld b, e_x(ix)

   sub b

   ;;
   ;;
   ;;


   jr z, no_colisionas     ;; =           
   jp m, no_colisionas     ;; <


     ;;=========COLISIONA EN EJE Y CON RIVAL================================
   ;;
   ;;if(rival_y + rival_h <= ball_y)
   ;; rival_y + rival_h - ball_y <= 0
   ld ix, #rival_data
   ld a, e_y(ix)
   ld c, a
   ld a, e_h(ix)
   add c

   ld ix, #ball_data
   ld b, e_y(ix)

   sub b

   jr z, no_colisionas      ;; =           
   jp m, no_colisionas      ;; <

   ;;if(ball_y + ball_h <= rival_y)
   ;; ball_y + ball_h - rival_y<= 0
   ld ix, #ball_data
   ld a, e_y(ix)
   ld c, a
   ld a, e_h(ix)
   add c

   ld ix, #rival_data
   ld b, e_y(ix)

   sub b

   jr z, no_colisionas     ;; =           
   jp m, no_colisionas      ;; <


   ;;----------COLISION*--------------------

  ;;----------COLISION*--------------------

   ld a, (vel_x)        ;;cargamos en a la velocidad de la pelota
   ld a, #-1          ;;la velocidad de la pelota pasa a ser 1
   ld (vel_x), a        ;; cargamos la velocidad

   ld a, (vel_y)
   cp #-1
   jr z, sube_1
   cp #1
   jr z, subes_1
   cp #0
   jr z, sube_1
   ret

   subes_1:
   ld a, #1
   ld (vel_y),a
   ret

   sube_1:
   ld a, #-1
   ld (vel_y),a
   ;;------------------------------------------

   ret 
   ;;=====================================================================
   no_colisionas:
   ld a, #00
   ret

   ;;===========================COLISION CON PALO (RIVAL)=========================
   ;;
   ;; if(ball_x + ball_w =< palo_rival_x) no_colisionan
   ;;
   ;; ball_x + ball_w - palo_rival_x <=0 , gracias ensamblador :D
   ld ix, #ball_data
   ld a, e_x(ix)
   ld a, b
   ld a, e_w(ix)
   add b


   ld ix, #palo_rival_data
   ld b, e_x(ix)
   sub b

   jr z, no_colisionass     ;; =           
   jp m, no_colisionass     ;; <

   ;;----------------COLISION-----------------------
   ld ix, #ball_data
   ld a, (vel_x)
   dec a
   ld (vel_x),a

   ;;-----------------------------------------------
   no_colisionass:
   ret

   ;;=====================================================================

;;-------------------------------------------------------

;;--------------MUEVE--------------------
;; !!!!!!!!!VER COMO PODER UTILIZAR ESTE CODIGO PARA LA PELOTA !!!!!
;; !!!!!!!!!            Y QUE NO PARE EN EL BORDE              !!!!!
mueve:          ;;va a ir hacia la derecha
   ld a, e_y(ix)
   cp #40
   jp z,techo
   cp #0x9A
   jp z,suelo

   ld a, e_x(ix)        ;;obtenemos la posicion de la pelota
   cp #80-8         ;;checkea el limite derecho (medida de la pantalla - caja size)
   jr z,goal_derecho  ;;si estas en el limite no te mueves y saltas a seguir checkeando
   cp #00       ;;checkea el limite derecho (medida de la pantalla - caja size)
   jr z,goal_izquierdo  ;;si estas en el limite no te mueves y saltas a seguir checkeando
   ld c, a          ;; nos guardamos a, para no perderla
   ld a, (vel_x)
   ld b,a
   ld a,c
    ;;
   add b          ;; le sumamos la velocidad
   ld e_x(ix), a
 
   ;;------------------------------------------------------
         ;;restamos 1 a hero_y
      ld a, (vel_x)       ;;cargamos el estado del salto
      cp #0               ;;comparo -1 con el estado del salto
      ret z                ;;devuelve cuando el flag Z esta activado
      ld a, (vel_y)

      ;; Hacer el salto
      ld b, a     ;; B=movimiento de salto
      ld a, e_y(ix)    ;; a=CAJA_Y
      add b          ;;sumamos a+b
      ld e_y(ix), a    ;;lo pasamos a la variable caja_y
      

   ;;------------------------------------------------------

   ret
    goal_derecho:
    ld a, e_y(ix) ;;SI GOL
    cp #0x5F         
    jp m,seguimos      ;; <

    ;; METE GOL
    ;;AUMENTAR CONTADOR DE GOLES Y ACTUALIZAR MARCADOR

    ;;=======================
    ;; UPDATE MARCADOR
    ;;=======================
   call sumaGol

    ;; RESET

    ret

  
    seguimos:
    ;;SI NO
    ;;BASICAMENTE INICIAMOS EL MOVIMIENTO OTRA VEZ
    ld a, (vel_x)
    dec a
    dec a
    ld (vel_x), a

    ld b, a
    ld ix, #ball_data
    ld a, e_x(ix)
    add b
    ld e_x(ix), a


    ret

    goal_izquierdo:
    ld a, e_y(ix) ;;SI GOL
    cp #0x5F
    jp m,seguimoss      ;; <

    ;; METE GOL

    call sumaGolContra

    ;;AUMENTAR CONTADOR DE GOLES Y ACTUALIZAR MARCADOR

    ret
    seguimoss:
    ;;SI NO, iniciamos el movimiento otra vez
    ld a, (vel_x)
    inc a
    inc a
    ld (vel_x), a

    ld  b,a

    ld a, e_x(ix)
    add b
    ld e_x(ix), a

    ret

    techo:
    ld a, #2
    ld (vel_y),a

    ld b, a

    ld a, e_y(ix)
    add b
    ld e_y(ix), a
    ret

    suelo:
    ld a, #-1
    ld (vel_y),a

    ld b, a

    ld a, e_y(ix)
    add b
    ld e_y(ix), a
    ret

    gol:
    ;;HEMOS MARCADO GOL

    ret
;;-----------------------------------------------

;;===================================================================
;; SKEREE MODO DIABLOOO
;;========================================================================