##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##  Copyright (C) 2018 Altered Vision (Tw:@alteredvision) / David Torrijos / Emilio Serrano / Jose MAnuel Malagón 
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------

.area _DATA
.area _CODE


;;include de symbols
.include "cpctelera.h.s"
.include "entity.h.s"
.include "global.h.s"
.include "palos.h.s"
.include "marcador.h.s"
.include "ball.h.s"

;;===============MACROS========================
DefineEntity rival_data, 0x30, 0x90, 0x14, 0x28, 0x01, #-1, _players_sp_1, rival_move;;rival numero 1            
         ;;               X,    Y,     W,    H,    vx, vy,  puntero a sprite, puntero a update    
;;==============================================

;;=================PLAYER======================
DefineEntity player_data, 0x01, 0x90, 0x14, 0x28, 0x01, #-1, _players_sp_0, entMoveKeyboard


;;=================FONDO======================
DefineEntity fondo_data, 0x00, 0xC7, 0x14, 0x32, 0x01, #-1, _fondo_sp, entMoveKeyboard



jumptable:
   .db #-12, #-12, #-6, #-2
   .db #-2, #00, #00, #00
   .db #00, #00, #00, #00        ;; SALTA 4 pixeles mas                               
   .db #04, #06, #12, #12        ;; de lo que mide(30)
   .db #0x80

parabola_x:
   .db #2, #2, #1, #1
   .db #1, #0, #0, #0
   .db #0x80

estadoia: .db #0

estadosalto: .db #-1

estadorival: .db #0


;;------------------DRAW---------------------------
;;DESTROYS: AF,BC,DE,HL
;--------------------------------------------------

entDraw::
   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                    ;;Y
   call cpct_getScreenPtr_asm

   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld b, e_h(ix)                    ;;Tamanyo
   ld c, e_w(ix)                    ;;Tamanyo

   call cpct_drawSprite_asm

   ret
   
;;-------------------------------------------------

entityReset::


;;==================
;; RESETEAMOS BALL
;;==================
   
   ld ix, #ball_data
   ld   a, #0x25        ;;reseteamos X
    ld   e_x(ix), a

    ld   a, #0x9A       ;;reseteamos Y
    ld   e_y(ix), a

    ld a, #00           ;;reseteamos v_y
    ld (vel_y),a

    ld a, b
    ld (vel_x),a       ;; reseteamos v_x

   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                    ;;Y
   call cpct_getScreenPtr_asm

   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld b, e_h(ix)                    ;;Tamanyo
   ld c, e_w(ix)                    ;;Tamanyo

   call cpct_drawSprite_asm

;;==================
;; RESETEAMOS PLAYER , RIVAL Y BALL
;;==================
ld ix, #player_data
call entClearPlayer

    ld   a, #0x01
    ld   e_x(ix), a

    ld   a, #0x90
    ld   e_y(ix), a

   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                    ;;Y
   call cpct_getScreenPtr_asm

   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld b, e_h(ix)                    ;;Tamanyo
   ld c, e_w(ix)                    ;;Tamanyo

   call cpct_drawSprite_asm

;;==================
;; RESETEAMOS RIVAL
;;==================

ld ix, #rival_data
call entClearPlayer
   ld   a, #0x30
    ld   e_x(ix), a

    ld   a, #0x90
    ld   e_y(ix), a

   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                    ;;Y
   call cpct_getScreenPtr_asm

   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld b, e_h(ix)                    ;;Tamanyo
   ld c, e_w(ix)                    ;;Tamanyo

   call cpct_drawSprite_asm

ret


;;------------------CLEAR---------------------------
;;DESTROYS: AF,BC,DE,HL
entClear::

   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)               ;;Y
   call cpct_getScreenPtr_asm
   
   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld hl, #_fondo_sp

   ld ix, #fondo_data
   ld b, #0x26                   ;;Tamanyo
   ld c, #0x25                    ;;Tamanyo


   call cpct_drawSprite_asm


   ret

entClearPlayer::

   ld a, e_y(ix)
   ld b,a
   ld a, #0x8F
   sub b

   jr z, paso_p
   jp m, paso_p

   ld de, #0xC000
   ld c, e_x(ix)                    ;;X
   ld b, e_y(ix)                ;;Y
   call cpct_getScreenPtr_asm
   
   ex de, hl                        ;;Puntero a memoria
   ld l, e_sp_l(ix)                 ;;leo el bajo
   ld h, e_sp_h(ix)                 ;;leo el alto
   ld hl, #_fondo_sp

   ld ix, #fondo_data
   ld b, e_h(ix)                    ;;Tamanyo
   ld c, e_w(ix)                    ;;Tamanyo


   call cpct_drawSprite_asm

   paso_p:
   ret
   
;;------------------------------------------------

;;-----------------BAJO TIERRA-------------------
arreglo:
      ld a, #0x9A
      ld e_y(ix), a
ret
;;------------------------------------------------

;;-----------------UPDATE--------------------------
entUpdate::
   ;;--------------PARCHE DEL BUG bajo tierra------------------------
   ld a, e_y(ix)
   ld b, #0x9A
   sub b
   jp m, seguimoh
   call arreglo
   ;;----------------------------------------------------------------
   seguimoh:
   call entJump
   ld h, e_up_h(ix) ;;cargo el byte alto
   ld l, e_up_l(ix) ;;cargo el byte bajo
   jp (hl)

;;------------------------------------------------

;;-------------------------RIVAL MOVE-----------------------------
rival_move:: ;; MAQUINA DE ESTADOSSSS PAPY

ld a, (estadoia)
cp #01
jp z, ia_2
	;;===========================IA 1==================================
  ;;-----ESTO en mi pueblo se llama SWITCH----------------
   ld a, (estadorival)
   cp #0                ;;si es 0
   jr z, estado_0_2
   cp #1
   jr z, estado_1_2       ;;si es 1
   cp #2
   jp z, estado_2_2       ;;si es 2
   ;;----------------------------------------------------

      estado_0_2: ;;---------ESTAR QUIETO------------------------
         ld ix, #ball_data ;;comprobamos donde esta la pelota
         ld a, e_x(ix)
         ld ix, #rival_data
         ld b, e_x(ix)
         sub b


         jp m, seg_2         ;;salto

         ld a, #1          ;;cambiamos el estado a 1
         ld (estadorival), a
         seg_2:

         ld ix, #rival_data
         ld a, e_x(ix)
         ld b, #62

         jr z,mue_2
         jp m, mue_2
         ret

         mue_2:
         ld ix, #rival_data
         ld a, e_x(ix)
         ld b,a
         ld a, #55

         sub b

         jr z,mue1_2
         jp m, mue1_2
         ret

         mue1_2:
         ld a, #2
         ld (estadorival),a

      ret
   ;;--------------------------------------------------------

      estado_1_2: ;;----------MOVIMIENTO sexy a la DERECHA---------
      ld ix, #rival_data   ;;MueveDerecha ---> C     80-8
                        ;;MUeveIzquierda ---> B   40


   ;;----------MOVEMOS DERECHA------------------------------
         ;;sumamos 1 a hero_x
         ld a, e_x(ix)    ;;cargamos la velocidad actual en a
         ld b, #1
         ld e_vx(ix), b
         ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
         cp #80-20         ;;checkea el limite derecho (medida de la pantalla - caja size)
         jr z,limite_derechoo_2  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;
         add e_vx(ix)             ;;incrementamos a
         ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
 
         ret
         limite_derechoo_2:
         ld a, #0
         ld (estadorival), a
      ret
   ;;---------------------------------------------------------

      estado_2_2: ;;-------------------MOVIMIENTO sexy a la IZQUIERDA--
         

         ld ix, #ball_data
         ld a,(vel_x)
         cp #1
         jr nz, limite_izquierdoo_2

         ld ix, #rival_data   ;;MueveDerecha ---> C     80-8
                        ;;MUeveIzquierda ---> B   40
   ;;----------MOVEMOS izquierda------------------------------
         ;;sumamos 1 a hero_x
         ld a, e_x(ix)    ;;cargamos la velocidad actual en a
         ld c, a
         ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
         ld b, #48        ;;checkea el limite derecho (medida de la pantalla - caja size)
         sub b
         jr z, limite_izquierdoo_2
         jp m, limite_izquierdoo_2  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;
         ld b, #-1
         ld a,c
         ld e_vx(ix), b

         add e_vx(ix)             ;;incrementamos a
         ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
         ret

         limite_izquierdoo_2:
         ld a, #0
         ld (estadorival), a
         ret

         ;;esperamos:
      ret
   ;;---------------------------------------------------------
   ret





	;;=================================================================
	

ia_2:
   ;;========================IA 2========================================	
   ;;-----ESTO en mi pueblo se llama SWITCH----------------
   ld a, (estadorival)
   cp #0                ;;si es 0
   jr z, estado_0
   cp #1
   jr z, estado_1       ;;si es 1
   cp #2
   jp z, estado_2       ;;si es 2
   ;;----------------------------------------------------

      estado_0: ;;---------ESTAR QUIETO------------------------
         ld ix, #ball_data ;;comprobamos donde esta la pelota
         ld a, e_x(ix)
         ld ix, #rival_data
         ld b, e_x(ix)
         sub b


         jp m, seg         ;;salto

         ld a, #1          ;;cambiamos el estado a 1
         ld (estadorival), a
         seg:

         ld ix, #rival_data
         ld a, e_x(ix)
         ld b, #62

         jr z,mue
         jp m, mue
         ret

         mue:
         ld ix, #rival_data
         ld a, e_x(ix)
         ld b,a
         ld a, #55

         sub b

         jr z,mue1
         jp m, mue1
         ret

         mue1:
         ld a, #2
         ld (estadorival),a

      ret
   ;;--------------------------------------------------------

      estado_1: ;;----------MOVIMIENTO sexy a la DERECHA---------
      ld ix, #rival_data   ;;MueveDerecha ---> C     80-8
                        ;;MUeveIzquierda ---> B   40
   ;;----------MOVEMOS DERECHA------------------------------
         ;;sumamos 1 a hero_x
         ld a, e_x(ix)    ;;cargamos la velocidad actual en a
         ld b, #1
         ld e_vx(ix), b
         ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
         cp #80-20         ;;checkea el limite derecho (medida de la pantalla - caja size)
         jr z,limite_derechoo  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;
         add e_vx(ix)             ;;incrementamos a
         ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
         ;;--------Posible salto-------------
         ld ix , #ball_data
         ld a, e_y(ix)
         ld b, #0x70
         sub b 

         jr z, saltaaa
         jp m, saltaaa

         ;;call startJump
         ;;call entJump
         ;;---------------------------------
         ret
         limite_derechoo:
         ld a, #0
         ld (estadorival), a
      ret
   ;;---------------------------------------------------------
      saltaaa:
      ld ix, #rival_data
      ld a, #-1
      ld e_vx(ix), a
         call startJump
         call entJump
      ret

      estado_2: ;;-------------------MOVIMIENTO sexy a la IZQUIERDA--
         

         ld ix, #ball_data
         ld a,(vel_x)
         cp #1
         jr nz, limite_izquierdoo

         ld ix, #rival_data   ;;MueveDerecha ---> C     80-8
                        ;;MUeveIzquierda ---> B   40
   ;;----------MOVEMOS izquierda------------------------------
         ;;sumamos 1 a hero_x
         ld a, e_x(ix)    ;;cargamos la velocidad actual en a
         ld c, a
         ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
         ld b, #48        ;;checkea el limite derecho (medida de la pantalla - caja size)
         sub b
         jr z, limite_izquierdoo
         jp m, limite_izquierdoo  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;
         ld b, #-1
         ld a,c
         ld e_vx(ix), b

         add e_vx(ix)             ;;incrementamos a
         ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
         ret

         limite_izquierdoo:
         ld a, #0
         ld (estadorival), a
         ret

         ;;esperamos:
      ret
   ;;---------------------------------------------------------
   ret
   ;;============================================================================
;;----------------------------------------------------------------
;;----------------------------------------------------------------

;;--------------MUEVE DERECHA--------------------
mueveDerecha:
         ;;D is pressed
      ;;sumamos 1 a hero_x
      ld a, e_x(ix)    ;;cargamos la velocidad actual en a
      ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
      cp c         ;;checkea el limite derecho (medida de la pantalla - caja size)
      jr z,limite_derecho  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;

      add e_vx(ix)             ;;incrementamos a
      ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
      limite_derecho:

      ret
;;-----------------------------------------------

;;--------------MUEVE IZQUIERDA--------------------
mueveIzquierda:
      ;;D is pressed
      ;;sumamos 1 a hero_x
      ld a, e_x(ix)    ;;cargamos la velocidad actual en a
      ;;CONTROLAMOS EL LIMITE DE LA PANTALLA
      cp b          ;;checkea el limite derecho (medida de la pantalla - caja size)
      jr z,limite_izquierdo  ;;si estas en el limite no te mueves y saltas a seguir checkeando
      ;;

      dec a             ;;incrementamos a
      ld e_x(ix), a       ;;cargamos a en la posicion de memoria de la velocidad
      limite_izquierdo:
      
      ret
;;-----------------------------------------------

;;---------------------CHECK INPUT--------------------
entMoveKeyboard:
;;Scaneamos el teclado
   call cpct_scanKeyboard_asm

;;(2B HL) key  A 16-bit value containing a Matrix-Line(1B, L) and a BitMask(1B, H).
   ld hl, #Key_P
   call cpct_isKeyPressed_asm
   cp    #0             ;;Resta el valor al acumulador (A), sin modificarlo
   jr z, p_not_pressed
      ld c, #40-18 ;; cargamos el limite derecho porque depende de la entidad :D
      call mueveDerecha ;;(le pasas por parametro C el limite)

   p_not_pressed:
      ld hl, #Key_O
      call cpct_isKeyPressed_asm
      cp #0
      jr z, o_not_pressed ;;if
         ld b, #0 ;;cargamos el limite de la derecha (como depende del player) :D
         call mueveIzquierda ;;(le pasas por parametro B el limite)

      o_not_pressed:       ;;else

         ld hl, #Key_Space
         call cpct_isKeyPressed_asm
         cp #0
         jr z, space_not_pressed ;;if

         call startJump

      space_not_pressed:

   ret

;;---------------------------------------------------------

;;-----------------------startJump---------------------------
startJump:
   ld a, e_vy(ix) ;;a=caja_jump
   cp #-1 ;;da 0 si coincide o sea si es -1 y -1
   ret nz

   ld a,#0
   ld e_vy(ix),a

   ret

;;-------------------------------------------------------------

;;------------------------entJump------------------------------
entJump:

      ;;restamos 1 a hero_y
      ld a, e_vy(ix)       ;;cargamos el estado del salto
      cp #-1               ;;comparo -1 con el estado del salto
      ret z                ;;devuelve cuando el flag Z esta activado

      ;;Obtenemos el valor del salto
      ld hl, #jumptable ;;tenemos que sumar a jumptable a 'a'
      ld c, a
      ld b, #0
      add hl, bc

      ;; Comprobar si el salto ha acabado
      ld a, (hl)
      cp #0x80
      jr z, continua

      ;; Hacer el salto
      ld b, a     ;; B=movimiento de salto
      ld a, e_y(ix)    ;; a=CAJA_Y
      add b          ;;sumamos a+b
      ld e_y(ix), a    ;;lo pasamos a la variable caja_y

      ;;Incrementamos los pasos del salto
      ld a, e_vy(ix)          ;;pillamos el valor de la variable
      inc a             ;;la incrementemos
      ld e_vy(ix),a  ;;y la volvemos a cargar a su sitio

      
      ret

      continua:

      ld    a, #-1      ;;acabamos el salto
      ld e_vy(ix), a

ret

;;BRAAAAASIIIIILLLLLLLLLL LALLALALALALALALALALALALALALALALALLALLALALALALALLALALA
;;LALALALALALALALLALALALALALALALLALALALALALALALALA
;; 495 :D
