##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##  Copyright (C) 2018 Altered Vision (Tw:@alteredvision) / David Torrijos / Emilio Serrano / Jose MAnuel Malagón 
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------

.area _DATA

;;
;; Start of _CODE area
;; 
.area _CODE

;; Para usar el Debug, abrir el Debug y luego hacer do
;; entonces el Debug se quedará parado en el main
;; F8 para avanzar en el debuger paso a paso
;; F7 para dar saltos


;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "entity.h.s"
.include "global.h.s"
.include "palos.h.s"
.include "ball.h.s"
.include "marcador.h.s"
.include "menu.h.s"
.include "mapa.h.s"
;.include "menu/inicio_pack1.h.s"
.include "mapa/tilemap_pack.h.s"

.include "mapa/tilemap.h.s"

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm
.globl cpct_setVideoMode_asm

.globl _paleta_b

antes_x: .db #00
antes_y: .db #00
;;


antes_x_rival: .db #00
antes_y_rival: .db #00
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;


;;decompress_buffer       == 0x040
;;menumaxsize             == 0x5ECC
;;decompress_buffer_end   == decompress_buffer + menumaxsize - 1

decompress_buffer       == 0x040
menumaxsize             == 0x5e8
decompress_buffer_end   == decompress_buffer + menumaxsize - 1
tileset_ptr             == decompress_buffer + 1000           
tilemap_ptr             == decompress_buffer + 0
tilemap_ptr1             == decompress_buffer + 500
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm



   ld c, #0
   call cpct_setVideoMode_asm   ;;Modo de video 0

   ld hl, #_paleta_b
   ld de, #16
   call cpct_setPalette_asm

;; ========DESCOMPRIMIMOS =======
   ld   hl, #_tilemap_pack_end
   ld   de, #decompress_buffer_end
   call cpct_zx7b_decrunch_s_asm

;; ========TOMAMOS DATOS PARA TILES =======
   ld bc ,#0x1414
   ld de ,#_tilemap_W
   ld hl ,#tileset_ptr

   call cpct_etm_setDrawTilemap4x8_ag_asm

;; ========PINTAMOS TILE =======
   ld hl, #0xC000
   ld de, #tilemap_ptr1

   call cpct_etm_drawTilemap4x8_ag_asm

   call menuInicio



   

   myloop:

   call cpct_scanKeyboard_asm
   ld    hl , #Key_Space
   call cpct_isKeyPressed_asm
   cp    #0
   jr    z, myloop

   call clear_screen




   call pintaMapa



   


loop:
   ;;-----------------PALITOS WEY---------------------

   call Dibujamos_palos
   call Dibujamos_palos_1

   ;;---------------PLAYER----------------------------

  
   ld ix, #player_data

   ;;ld a, e_y(ix)
   ;;ld b,a
;;
   ;;ld a, #0x90
   ;;sub b
   
   ;;jp m, paso

   call entClearPlayer     ;;borramos el player
   ld ix, #player_data

   ;;paso:
   
   call entUpdate
   
   ld hl, #_players_sp_1
   call entDraw         ;;dibujamos el player


   ;;ld a, e_x(ix)
   ;;ld (antes_x),a
   ;;ld a, e_y(ix)
   ;;ld (antes_y),a
   ;;------------------------------------------------

   ;;------------------RIVAL--------------------------
   ld ix, #rival_data
      ;;ld a, e_y(ix)
   ;;ld b,a

   ;;ld a, #0x90
   ;;sub b
   
   ;;jp m, paso_2

   call entClearPlayer     ;;borramos el player

   ld ix, #rival_data

   ;;paso_2:




   ;;ld a, (antes_x_rival)
   ;;ld b, a
   ;;ld a, e_x(ix)

   ;;sub b

   ;;jr z, paso_1

   ;;ld a, (antes_y_rival)
   ;;ld b, a
   ;;ld a, e_y(ix)

   ;;sub b

   ;;jr z, paso_1
   
   ;;call entClearPlayer     ;;borramos el player

   ;;paso_1:
   
   call entUpdate 

   ld hl, #_players_sp_1 
   call entDraw         ;;dibujamos el player


   ;;ld a, e_x(ix)
   ;;ld (antes_x_rival),a
   ;;ld a, e_y(ix)
   ;;ld (antes_y_rival),a
   ;;------------------------------------------------
   ;;------------------------------------------------

       ;;------------------BALL--------------------------
   ld ix, #ball_data
   ;call borraBall
   call entDraw
   call entBallUpdate
   
   ;;------------------------------------------------




   call cpct_waitVSYNC_asm


jr loop