##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##  Copyright (C) 2018 Altered Vision (Tw:@alteredvision) / David Torrijos / Emilio Serrano / Jose MAnuel Malagón 
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------

.area _DATA
.area _CODE

.include "entity.h.s"
.include "marcador.h.s"
.include "global.h.s"
.include "cpctelera.h.s"
.include "menu.h.s"
.include "palos.h.s"
.include "ball.h.s"
.include "mapa.h.s"


;.globl _gol_sp	
score_a::  .db #00
score_b::  .db #00

DefineEntity marcador_player_data, 0x14, 0x0e, 0x06, 0x0b, 0x01, #-1, _punto_sp, entUpdate 
DefineEntity marcador_rival_data, 0x2c, 0x0e,  0x06, 0x0b, 0x01, #-1, _punto_sp, entUpdate 
DefineEntity victoria_data, 0x17, 0x40, 0x1e, 0x3c, 0x01, #-1, _victoria_sp, 0
DefineEntity derrota_data, 0x17, 0x40, 0x1e, 0x3c, 0x01, #-1, _derrota_sp, 0 

							; X     Y     W    H     


sumaGol::

ld    a,(score_a)   	;; A = score_a
cp    #01 				;; Si a == 1
jr    z,scoreDos 		;; | 	Seguimos sino scorDos

ld 	  a,(score_a)		
cp    #02
jr    z,youWin 


ld    b, #01      ;; A = score_a
ld 	  a, (score_a)
add   b
    
ld    (score_a), a      ;; score_a = A
ld     ix, #marcador_player_data

call entDraw

ld ix, #ball_data
call entClear
ld ix, #player_data
call entClear
ld ix, #rival_data
call entClear

call pintaSuelo
ld b, #1
call entityReset 


ret
scoreDos::

		
		ld 	  a,(score_a)		
        cp    #02
        jr    z,youWin 

        ld    b, #01      ;; A = score_a
    	ld 	  a, (score_a)
    	add   b
		
		ld    (score_a), a      ;; score_a = A

 	    ld     ix, #marcador_player_data
     	ld 		b, #0x05
     	ld 		a,e_x(ix)
     	add 	b

        ld 	e_x(ix), a

    	call entDraw

    	ld ix, #ball_data
		call entClear
		ld ix, #player_data
		call entClear
		ld ix, #rival_data
		call entClear

		call pintaSuelo
        ld b, #1
    	call entityReset  
    	call pintaSuelo
ret
youWin::

		ld     ix, #marcador_player_data
     	ld 		b, #0x05
     	ld 		a,e_x(ix)
     	add 	b

        ld 	e_x(ix), a

    	call entDraw

    	ld ix, #ball_data
		call entClear
		ld ix, #player_data
		call entClear
		ld ix, #rival_data
		call entClear

		call pintaSuelo

    	call entityReset 

		call pintaSuelo 

    	ld 		ix,#victoria_data
    	call entDraw

    	ld ix, #player_data
        call entDraw

        ld ix, #rival_data
        call entDraw

        myloop:

        call cpct_scanKeyboard_asm
        ld    hl , #Key_Space
        call cpct_isKeyPressed_asm
        cp    #0
        jr    z, myloop

        ld a, #0			;; PONEMOS EL SCORE A 0
        ld (score_a), a
        ld (score_b), a
        ld (vel_x), a


        call clear_screen		;;LIMPIAMOS LA PANTALLA

       	call pintaMapa
        ;;TENEMOS QUE DIBUJAR LA PANTALLA

    	;;-------------------PALO PLAYER----------------
   		ld ix, #palo_player_data
   		call entDraw
   		;;----------------------------------------------

   		;;-------------------PALO PLAYER----------------
   		ld ix, #palo_rival_data
   		call entDraw
   		;;----------------------------------------------
   		ld a, #01
   		ld (estadoia), a 				;;cargamos la siguiente IA
        ld hl, #_players_sp_2
        ld ix , #rival_data
        ld e_sp_l(ix), l                 ;;Cargamos el Sprite
		ld e_sp_h(ix), h                 ;;

ret



sumaGolContra::

ld    a,(score_b)   	;; A = score_a
cp    #01 				;; Si a == 1
jr    z,scoreDosContra 		;; | 	Seguimos sino scorDos

ld 	  a,(score_b)		
cp    #02
jr    z,youLose 


ld    b, #01      ;; A = score_a
ld 	  a, (score_b)
add   b
    
ld    (score_b), a      ;; score_a = A
ld     ix, #marcador_rival_data
call entDraw

ld ix, #ball_data
call entClear
ld ix, #player_data
call entClear
ld ix, #rival_data
call entClear
call pintaSuelo
ld b, #-1
call entityReset   
ret

scoreDosContra::
		
		ld 	  a,(score_b)		
        cp    #02
        jr    z,youLose 

        ld    b, #01      ;; A = score_a
    	ld 	  a, (score_b)
    	add   b
		
		ld    (score_b), a      ;; score_a = A

 	    ld     ix, #marcador_rival_data
     	ld 		b, #0x05
     	ld 		a,e_x(ix)
     	add 	b

        ld 	e_x(ix), a

    	call entDraw

		ld ix, #ball_data
		call entClear
    	ld ix, #player_data
		call entClear
		ld ix, #rival_data
		call entClear
		call pintaSuelo
        ld b, #1
    	call entityReset  
ret
youLose::

		ld     ix, #marcador_rival_data
     	ld 		b, #0x05
     	ld 		a, e_x(ix)
     	add 	b

        ld 	e_x(ix), a

    	call entDraw


    	ld a, #01
   		ld (estadoia), a 				;;cargamos la siguiente IA

   		ld hl, #_players_sp_1
        ld ix , #rival_data
        ld e_sp_l(ix), l                 ;;Cargamos el Sprite
		ld e_sp_h(ix), h                 ;;

		ld ix, #ball_data
		call entClear
		ld ix, #player_data
		call entClear
		ld ix, #rival_data
		call entClear

		call pintaSuelo
    	call entityReset 

    	ld 	ix,#derrota_data
    	call entDraw

        myloop_2:

        call cpct_scanKeyboard_asm
        ld    hl , #Key_Space
        call cpct_isKeyPressed_asm
        cp    #0
        jr    z, myloop_2


        ld a, #0			;; PONEMOS EL SCORE A 0
        ld (score_a), a
        ld (score_b), a
        ld (vel_x), a
        ld (vel_y), a
        ld (estadoia),a

        call clear_screen		;;LIMPIAMOS LA PANTALLA
        call pintaMapa

        ;;TENEMOS QUE DIBUJAR LA PANTALLA

    	;;-------------------PALO PLAYER----------------
   		ld ix, #palo_player_data
   		call entDraw
   		;;----------------------------------------------

   		;;-------------------PALO PLAYER----------------
   		ld ix, #palo_rival_data
   		call entDraw
   		;;----------------------------------------------


ret
